<template>
  <div>
    <div id="nav">
      <Header />
    </div>

    <h1>Ecrire un message</h1>

    <div class="createMessage" v-if="$store.state.isUserLoggedIn">
      <div v-html="$store.state.user"></div>

      <div class="fields">

<label for="title">Votre titre</label>
      
        <input
          class="title"
          type="text"
          name="title"
          v-model="title"
        />

        <label for="body">Votre message</label>

        <textarea
          id="body"
          name="body"
          rows="5"
          cols="33"
          v-model="body"
        ></textarea>
      </div>

      <div class="error" v-html="error" />

      <button v-on:click="createMessage">Poster</button>
    </div>

    <div class="notconnectedMsg" v-else>
      <p>Vous devez être connecté pour avoir accès à cette page</p>
      <router-link class="user-link" to="/"
        >S'inscrire / Se connecter</router-link
      >
    </div>
  </div>
</template>

<script>
import MessagesService from "@/services/MessagesService";
import Header from "@/components/Header";
import axios from "axios";

export default {
  name: "createMessage",
  components: {
    Header,
  },

  data() {
    return {
      title: "",
      body: "",
      error: null,
    };
  },

  async mounted() {
    // do a request once the page is loaded to the backend to fetch all messages
    try {
      const token = localStorage.getItem("token");
      if (token !== null) {
        this.$store.dispatch("setToken", token);
        axios.defaults.headers.common["Authorization"] = token;
      }
    } catch (error) {
      if (error.response.status == 403) {
        localStorage.removeItem("token")
        this.$store.dispatch("setToken", null);
      } else {
      this.error = error.response.data.error;
    }
    }
  },

  methods: {
    async createMessage() {
      try {
        const username = localStorage.getItem("username");
        await MessagesService.createMessage({
          title: this.title,
          author: username,
          body: this.body,
        });
        this.$router.push("messages");
      } catch (error) {
        this.error = error.response.data.error;
      }
    },
  },
};
</script>

<style scoped>
h1 {
  color: #d1515a;
  margin-bottom: 50px;
}
.error {
  color: red;
}
label {
  font-style: italic;
}
input.title {
  border-radius: 10px;
  height: 40px;
  margin-bottom: 20px;
  margin-top: 5px;
  padding: 0 10px;
}

textarea {
  border-radius: 10px;
  height: 80px;
  margin-bottom: 20px;
  margin-top: 5px;
  padding: 5px 10px;
}
.fields {
  display: flex;
  flex-direction: column;
  margin: 0 auto;
  width: 40%;
}
button {
  margin-top: 10px;
  border-radius: 10px;
  padding: 10px 50px;
  font-size: 0.9rem;
  background-color: #091f43;
  color: white;
}
@media (min-width: 600px) and (max-width: 985px) {
  h1 {
  margin-top: 20px;
}
  .fields {
  width: 60%;
}
}
@media (max-width: 599px) {
    h1 {
  margin-top: 20px;
}
  .fields {
  width: 80%;
}
}
</style>

